#include <hpgcc49.h>
#include <hpgraphics.h>
#include "md2.h"

extern char *__heap_ptr;
char *md2name;
FILE *filehandle = NULL;
MD2_HEADER md2_header;
MD2_CONTAINER md2_container;
VECTOR4D md2_vscale = { 4, 4, 4, 1 };
POINT4D cam_pos = { 0, 0, 0, 1 };
VECTOR4D cam_dir = { 0, 0, 0, 1 };
OBJECT obj_model;
CAMERA cam;
MATRICE mrot;
float x_angle = 0.0; float y_angle = 0.0; float z_angle = 0.0;
char buffer[50];
int free_memory, frame_size;
int md2_animations[20] = {0,40,46,54,58,62,66,72,84,95,112,123,135,154,160,169,173,178,184,190};
int md2_animation_index = -1;
FRAME_BUFFER frame_buffer;
MD2_FRAME md2_frame;
MD2_POINT md2_point;
MD2_POLYGONE md2_polygone;
int raster_x[3], raster_y[3];

int main()
{
	int polygone, vertex;
    POINT4D presult;
	int col,row;
	float sum;

    hpg_clear();
    md2name = sat_stack_pop_string_alloc();

    if (md2name == NULL) { printf("Error: MD2 file name expected\n"); keyb_getkey(1); return 0; }
	if (!load_md2file(md2name)) return 0;

    hpg_set_mode_gray16(1); hpg_clear(); hpg_flip(); hpg_clear();

    Init_CAM4DV1(&cam, &cam_pos, &cam_dir, 10.0, 500.0, 90.0, WINDOW_WIDTH, WINDOW_HEIGHT);

	float ivalue = 0.0;
	float frame_increment = 0.5;
    
	sys_slowOff();
    while (!keyb_isON()) {
// 																								extract frame from md2_container 
		int base_index_0 = md2_header.num_verts * ((int) frame_buffer.frame_played_inbuffer);
		int base_index_1 = md2_header.num_verts * ((int) frame_buffer.frame_played_inbuffer + 1);
		int vindex;
		for (vindex = 0; vindex < md2_header.num_verts; vindex++) {
			obj_model.vlist[vindex].x =((1.0 - ivalue)*md2_container.vlist[vindex + base_index_0].x + ivalue * md2_container.vlist[vindex + base_index_1].x);
			obj_model.vlist[vindex].y =((1.0 - ivalue)*md2_container.vlist[vindex + base_index_0].y + ivalue * md2_container.vlist[vindex + base_index_1].y);
			obj_model.vlist[vindex].z =((1.0 - ivalue)*md2_container.vlist[vindex + base_index_0].z + ivalue * md2_container.vlist[vindex + base_index_1].z);
			obj_model.vlist[vindex].w = 1.0;	
		} 
// 																								reset backface flag
		for (polygone = 0; polygone < obj_model.num_polys; polygone++) {
			obj_model.plist[polygone].backface = 0;
		}
// 																								read keyboard
		if (keyb_isAnyKeyPressed()) {
			if (keyb_isRight()) y_angle -= 0.1;
			else if (keyb_isLS()) { 
				if (keyb_isUp()) z_angle += 0.1;
				else if (keyb_isDown()) z_angle -= 0.1;
				else if (keyb_isKeyPressed(3, 6)) md2_animation_index = 0;
				else if (keyb_isKeyPressed(3, 5)) md2_animation_index = 1;
				else if (keyb_isKeyPressed(2, 5)) md2_animation_index = 2;
				else if (keyb_isKeyPressed(1, 5)) md2_animation_index = 3;
				else if (keyb_isKeyPressed(3, 4)) md2_animation_index = 4;
				else if (keyb_isKeyPressed(2, 4)) md2_animation_index = 5;
				else if (keyb_isKeyPressed(1, 4)) md2_animation_index = 6;
				else if (keyb_isKeyPressed(3, 3)) md2_animation_index = 7;
				else if (keyb_isKeyPressed(2, 3)) md2_animation_index = 8;
				else if (keyb_isKeyPressed(1, 3)) md2_animation_index = 9;
			} 
			else if (keyb_isRS()) {
				if (keyb_isKeyPressed(3, 6)) md2_animation_index = 10;
				else if (keyb_isKeyPressed(3, 5)) md2_animation_index = 11;
				else if (keyb_isKeyPressed(2, 5)) md2_animation_index = 12;
				else if (keyb_isKeyPressed(1, 5)) md2_animation_index = 13;
				else if (keyb_isKeyPressed(3, 4)) md2_animation_index = 14;
				else if (keyb_isKeyPressed(2, 4)) md2_animation_index = 15;
				else if (keyb_isKeyPressed(1, 4)) md2_animation_index = 16;
				else if (keyb_isKeyPressed(3, 3)) md2_animation_index = 17;
				else if (keyb_isKeyPressed(2, 3)) md2_animation_index = 18;
				else if (keyb_isKeyPressed(1, 3)) md2_animation_index = 19;
			} 
			else {
				if (keyb_isUp()) x_angle += 0.1;
				else if (keyb_isDown()) x_angle -= 0.1;
				else if (keyb_isLeft()) y_angle += 0.1;
				else if (keyb_isKeyPressed(1, 4)) {if (obj_model.world_pos.x < 150.0) obj_model.world_pos.x += 5.0;} 
				else if (keyb_isKeyPressed(3, 4)) {if (obj_model.world_pos.x > -150.0) obj_model.world_pos.x -= 5.0;} 
				else if (keyb_isKeyPressed(2, 3)) {if (obj_model.world_pos.y < 150.0) obj_model.world_pos.y += 5.0;}
				else if (keyb_isKeyPressed(2, 5)) {if (obj_model.world_pos.y > -150.0) obj_model.world_pos.y -= 5.0;}
				else if (keyb_isKeyPressed(0, 5)) {if (obj_model.world_pos.z > 80.0) obj_model.world_pos.z -= 5.0;}
				else if (keyb_isKeyPressed(0, 4)) {if (obj_model.world_pos.z < 300.0) obj_model.world_pos.z += 5.0;}
				else if (keyb_isKeyPressed(6, 5)) {
					hpg_clear();
					sprintf(buffer, "file name: %s", md2name);
					hpg_draw_text(buffer, 0, 0);
					sprintf(buffer, "   num. of vertices...%d",md2_header.num_verts);
					hpg_draw_text(buffer, 0, 8);
					sprintf(buffer, "   num. of triangles..%d",md2_header.num_polys);
					hpg_draw_text(buffer, 0, 16);
					sprintf(buffer, "   num. of frames.....%d",md2_header.num_frames);
					hpg_draw_text(buffer, 0, 24);
					sprintf(buffer, "   frame size.........%d bytes",frame_size);
					hpg_draw_text(buffer, 0, 32);
					sprintf(buffer, "   frames in buffer...%d",frame_buffer.buffer_capacity);
					hpg_draw_text(buffer, 0, 40);
					hpg_flip(); keyb_getkey(1);
				}
			}
		}		
		
		build_rotation_matrice(x_angle, y_angle, z_angle, &mrot);	
		build_camera(&cam);
// 																								rotation in model space & translation into world space
// 																								then world coordinates to camera coordinates
		for (vertex = 0; vertex < obj_model.num_vertices; vertex++) {
			for (col = 0; col < 4; col++) {       						
				sum = 0; 
				for (row = 0; row < 4; row++) {
					sum += (obj_model.vlist[vertex].v.M[row] * mrot.M[row][col]);
				} 
				presult.M[col] = sum;
			} 
			obj_model.vlist[vertex].v.x = presult.x + obj_model.world_pos.x; 
			obj_model.vlist[vertex].v.y = presult.y + obj_model.world_pos.y;
			obj_model.vlist[vertex].v.z = presult.z + obj_model.world_pos.z; 
			obj_model.vlist[vertex].v.w = 1;	
			for (col = 0; col < 4; col++) {       						
				sum = 0; 
				for (row = 0; row < 4; row++) {
					sum += (obj_model.vlist[vertex].v.M[row] * cam.mcam.M[row][col]);
				} 
				presult.M[col] = sum;
			} 
			obj_model.vlist[vertex].v.x = presult.x; obj_model.vlist[vertex].v.y = presult.y;
			obj_model.vlist[vertex].v.z = presult.z; obj_model.vlist[vertex].v.w = presult.w;	
		}
		
// 																								sort polygones list on z average value 
		qsort((void *) obj_model.pplist, obj_model.num_polys,sizeof(POLYGONE_PTR), compare_polygone);
// 																								remove Backfaces
		for (polygone = 0; polygone < obj_model.num_polys; polygone++) {
			POLYGONE_PTR curr_poly = &obj_model.plist[polygone];
			VECTOR4D u, v, n, view;
			u.x = obj_model.vlist[curr_poly->vert[1]].v.x - obj_model.vlist[curr_poly->vert[0]].v.x;		// edge 1 of triangle
			u.y = obj_model.vlist[curr_poly->vert[1]].v.y - obj_model.vlist[curr_poly->vert[0]].v.y;
			u.z = obj_model.vlist[curr_poly->vert[1]].v.z - obj_model.vlist[curr_poly->vert[0]].v.z;
			u.w = 1;
			v.x = obj_model.vlist[curr_poly->vert[2]].v.x - obj_model.vlist[curr_poly->vert[0]].v.x;		// edge 2 of triangle
			v.y = obj_model.vlist[curr_poly->vert[2]].v.y - obj_model.vlist[curr_poly->vert[0]].v.y;
			v.z = obj_model.vlist[curr_poly->vert[2]].v.z - obj_model.vlist[curr_poly->vert[0]].v.z;
			v.w = 1;
			n.x = ( (u.y * v.z) - (u.z * v.y) ); n.y = -( (u.x * v.z) - (u.z * v.x) );		// cross product: normal to the triangle			
			n.z = ( (u.x * v.y) - (u.y * v.x) ); n.w = 1;
			view.x = cam.pos.x - obj_model.vlist[curr_poly->vert[0]].v.x;						// vector between objet and camera
			view.y = cam.pos.y - obj_model.vlist[curr_poly->vert[0]].v.y;
			view.z = cam.pos.z - obj_model.vlist[curr_poly->vert[0]].v.z;
			view.w = 1;
			float dp = (n.x * view.x) + (n.y * view.y) + (n.z * view.z); 					// dot product 
			if (dp <= 0.0) curr_poly->backface |= BACKFACE;
		}
// 																								camera coordinates to screen coordinates
		float alpha = (0.5 * cam.viewport_width - 0.5);
		float beta = (0.5 * cam.viewport_height - 0.5);
		for (vertex = 0; vertex < obj_model.num_vertices; vertex++) {
			float z = obj_model.vlist[vertex].z;
			if(z == 0.0) z = EPSILON_E5;
			obj_model.vlist[vertex].x = cam.view_dist * obj_model.vlist[vertex].x / z;
			obj_model.vlist[vertex].y = cam.view_dist * obj_model.vlist[vertex].y * cam.aspect_ratio / z;
			obj_model.vlist[vertex].x = alpha + alpha * obj_model.vlist[vertex].x;
			obj_model.vlist[vertex].y = beta - beta * obj_model.vlist[vertex].y;
		}
// 																								draw object
		hpg_clear();
		for (polygone = 0; polygone < md2_header.num_polys; polygone++) {
			if (obj_model.pplist[polygone]->backface & BACKFACE) continue;
			raster_x[0] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[0]].x;
			raster_y[0] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[0]].y;
			raster_x[1] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[1]].x;
			raster_y[1] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[1]].y;
			raster_x[2] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[2]].x;
			raster_y[2] = (int) obj_model.vlist[obj_model.pplist[polygone]->vert[2]].y;
			hpg_set_color(hpg_stdscreen, HPG_COLOR_GRAY_6); hpg_fill_polygon(raster_x, raster_y, 3);
			hpg_set_color(hpg_stdscreen, HPG_COLOR_BLACK); hpg_draw_polygon(raster_x, raster_y, 3);			
		}
		hpg_flip();
// 																													animation logic
		int start, end;
		VECTOR3D_PTR vertex_pointer;
		int findex;
		float temp;
		VECTOR3D v;
		if (md2_animation_index != -1 && md2_header.num_frames >= 198) {											// if a animation is called
			start = md2_animations[md2_animation_index];
			if (start != frame_buffer.frame_first_infile) {
				frame_buffer.frame_first_infile = start;
				end = min(frame_buffer.buffer_capacity,md2_header.num_frames - start);
				frame_buffer.num_frames_inbuffer = end;
				vertex_pointer = md2_container.vlist;
				fseek(filehandle, md2_header.offset_frames + md2_header.framesize * start, SEEK_SET);				// point on the first frame
				for (findex = 0; findex < end; findex++) {															// loop on the number of frames to read
					fread((void *) &md2_frame, 1, sizeof(md2_frame), filehandle);								// read the frame header
					for (vindex = 0; vindex < md2_header.num_verts; vindex++, vertex_pointer++) {					// loop on the number of vertices
						fread((void *) &md2_point, 1, sizeof(md2_point), filehandle);							// read the compressed vertex
						v.x = (float) md2_point.v[0] * md2_frame.scale[0] + md2_frame.translate[0];				// uncompressed the vertex
						v.y = (float) md2_point.v[1] * md2_frame.scale[1] + md2_frame.translate[1];
						v.z = (float) md2_point.v[2] * md2_frame.scale[2] + md2_frame.translate[2];
						v.x = md2_vscale.x * v.x; v.y = md2_vscale.y * v.y; v.z = md2_vscale.z * v.z;				// scale the model
						SWAP(v.y, v.z, temp);																		// rhs to lhs
						vertex_pointer->x = v.x; vertex_pointer->y = v.y; vertex_pointer->z = v.z;				// write the vertex in memory
					}
				}
			}
		md2_animation_index = -1;
		frame_buffer.frame_played_inbuffer = 0.0;
		} 
		else {
			frame_buffer.frame_played_inbuffer += frame_increment;
			ivalue = frame_buffer.frame_played_inbuffer - (int) frame_buffer.frame_played_inbuffer;
			if( ivalue == 0.0 ) {																					// next frame
				if( (int) frame_buffer.frame_played_inbuffer + 1 == frame_buffer.num_frames_inbuffer ) {			// if next frame is not buffered
					start = (int) frame_buffer.frame_played_inbuffer + frame_buffer.frame_first_infile; 
					if( start == md2_header.num_frames - 1 ) start = 0;
					frame_buffer.frame_first_infile = start;
					end = min( frame_buffer.buffer_capacity, md2_header.num_frames - start );
					frame_buffer.num_frames_inbuffer = end;
					VECTOR3D_PTR vertex_pointer = md2_container.vlist;
					fseek (filehandle, md2_header.offset_frames + md2_header.framesize * start, SEEK_SET);			// point on the first frame
					for (findex = 0; findex < end; findex++) {														// loop on number of frames to read
						fread ( (void *) &md2_frame, 1, sizeof (md2_frame), filehandle );						// read the frame header
						for (vindex = 0; vindex < md2_header.num_verts; vindex++, vertex_pointer++) {				// loop on the number of vertices
							fread ( (void *) &md2_point, 1, sizeof(md2_point), filehandle );						// read the compressed vertex
							v.x = (float) md2_point.v[0] * md2_frame.scale[0] + md2_frame.translate[0];			// uncompressed the vertex
							v.y = (float) md2_point.v[1] * md2_frame.scale[1] + md2_frame.translate[1];
							v.z = (float) md2_point.v[2] * md2_frame.scale[2] + md2_frame.translate[2];
							v.x = md2_vscale.x * v.x; v.y = md2_vscale.y * v.y; v.z = md2_vscale.z * v.z;			// scale the model
							SWAP(v.y, v.z, temp);																	// rhs to lhs
							vertex_pointer->x = v.x; vertex_pointer->y = v.y; vertex_pointer->z = v.z;			// write the vertex in memory
						}
					}
					frame_buffer.frame_played_inbuffer = 0.0;
				}
			}
		}
	}
    sys_slowOn(); fclose(filehandle); return 1;
}

int load_md2file(char *md2name)
{
    filehandle = fopen(md2name, "rb");
    if (filehandle == NULL) { printf("Error: couldn't find file %s", md2name); keyb_getkey(1); return (0);}
    fread((void *) &md2_header, 1, sizeof(md2_header), filehandle);
    if (md2_header.identifier != MD2_ID || md2_header.version != MD2_VERSION) {
		printf("Error: not a valid MD2 file %s", md2name); keyb_getkey(1); fclose(filehandle); return (0);}

	obj_model.num_vertices = md2_header.num_verts; obj_model.num_polys = md2_header.num_polys;
    obj_model.world_pos.x = 0; obj_model.world_pos.y = 0; obj_model.world_pos.z = 200; obj_model.world_pos.w = 1;
	obj_model.vlist = (VERTEX_PTR) malloc(obj_model.num_vertices * sizeof(VERTEX));
	obj_model.plist = (POLYGONE_PTR) malloc(sizeof(POLYGONE) * obj_model.num_polys);
    obj_model.pplist = (POLYGONE_PTR *) malloc(sizeof(POLYGONE_PTR) * obj_model.num_polys);
	if (obj_model.vlist == NULL || obj_model.plist == NULL || obj_model.pplist == NULL) {
		printf("Error: insufficient memory!"); keyb_getkey(1); fclose(filehandle); return (0);}
// 																											compute free memory
// found there: http://groups.google.com/group/comp.sys.hp48/browse_thread/thread/26cc62e8f1d63121/4cb62084455c4efd?lnk=gst&q=asm(%22sp%22)#
    register unsigned int stack_ptr asm("sp");
    unsigned int base;
    base = (__heap_ptr == 0) ? _heap_base_addr : (int) __heap_ptr;
    free_memory = stack_ptr - base;
    free_memory -= 40000;
    frame_size = md2_header.num_verts * sizeof(VECTOR3D);
    frame_buffer.buffer_capacity = min((free_memory / frame_size), md2_header.num_frames);
// 																											need at least 2 frames to play a animation
// 																											look for a block of free memory to store the frames
    while (1) {
		md2_container.vlist = (VECTOR3D_PTR) malloc(frame_buffer.buffer_capacity * frame_size);
		if (md2_container.vlist == NULL) {
			if (frame_buffer.buffer_capacity < 2) { printf("Error: insufficient memory!"); keyb_getkey(1); fclose(filehandle); return (0);}
			else frame_buffer.buffer_capacity -= 1;
		} else break;
    }

    frame_buffer.num_frames_inbuffer = frame_buffer.buffer_capacity;
    frame_buffer.frame_played_inbuffer = 0.0;
    frame_buffer.frame_first_infile = 0;

    VECTOR3D_PTR vertex_pointer = md2_container.vlist;
    fseek (filehandle, md2_header.offset_frames, SEEK_SET);													// point on the first frame
	
    printf("          LOADING FILE...");

    sys_slowOff();
    int findex;																									// fill frame buffer
    for (findex = 0; findex < frame_buffer.buffer_capacity; findex++) {										// loop on number of frames to read
		fread((void *) &md2_frame, 1, sizeof(md2_frame), filehandle);										// read the frame header
		int vindex;
		for (vindex = 0; vindex < md2_header.num_verts; vindex++, vertex_pointer++) {							// loop on the number of vertices
			VECTOR3D v;
			fread((void *) &md2_point, 1, sizeof(md2_point), filehandle);									// read the compressed vertex
			v.x = (float) md2_point.v[0] * md2_frame.scale[0] + md2_frame.translate[0];						// uncompressed the vertex
			v.y = (float) md2_point.v[1] * md2_frame.scale[1] + md2_frame.translate[1];
			v.z = (float) md2_point.v[2] * md2_frame.scale[2] + md2_frame.translate[2];
			v.x = md2_vscale.x * v.x; v.y = md2_vscale.y * v.y; v.z = md2_vscale.z * v.z;						// scale the model
			float temp; SWAP(v.y, v.z, temp);																	// rhs to lhs
			vertex_pointer->x = v.x; vertex_pointer->y = v.y; vertex_pointer->z = v.z;						// write the vertex in memory
		}
    }
	
    fseek(filehandle, md2_header.offset_polys, SEEK_SET);
    int pindex;
    for (pindex = 0; pindex < md2_header.num_polys; pindex++) {												// read polygones list in object 
		fread((void *) &md2_polygone, 1, 6, filehandle);
		fseek(filehandle, 6, SEEK_CUR);
		obj_model.plist[pindex].vert[0] = (int) md2_polygone.vindex[0];
		obj_model.plist[pindex].vert[1] = (int) md2_polygone.vindex[1];
		obj_model.plist[pindex].vert[2] = (int) md2_polygone.vindex[2];
		obj_model.plist[pindex].vlist = obj_model.vlist;
		obj_model.pplist[pindex] = &obj_model.plist[pindex];
    }
    sys_slowOn();
    return 1;
}

int compare_polygone(const void *arg1, const void *arg2) {
	float z1, z2;
	POLYGONE_PTR poly_1, poly_2;
	poly_1 = *((POLYGONE_PTR *)(arg1)); poly_2 = *((POLYGONE_PTR *)(arg2));
	z1 = (float)0.33333*(poly_1->vlist[poly_1->vert[0]].z + poly_1->vlist[poly_1->vert[1]].z + poly_1->vlist[poly_1->vert[2]].z);
	z2 = (float)0.33333*(poly_2->vlist[poly_2->vert[0]].z + poly_2->vlist[poly_2->vert[1]].z + poly_2->vlist[poly_2->vert[2]].z);
	if (z1 > z2) return(-1); else if (z1 < z2) return(1); else return(0);
} 

void init_plane(PLANE_PTR plane, POINT3D_PTR p0, VECTOR3D_PTR normal) {
	plane->p0.x = p0->x;plane->p0.y = p0->y;plane->p0.z = p0->z;								
	float length = (float) sqrt( normal->x * normal->x + normal->y * normal->y + normal->z * normal->z);
	if (length < EPSILON_E5) return;							
	plane->n.x = normal->x / length; plane->n.y = normal->y / length; plane->n.z = normal->z / length;
} 

void init_matrice(MATRICE_PTR ma,	float m00, float m01, float m02, float m03, float m10, float m11, float m12, float m13,
										float m20, float m21, float m22, float m23, float m30, float m31, float m32, float m33) {
	ma->M00 = m00; ma->M01 = m01; ma->M02 = m02; ma->M03 = m03;
	ma->M10 = m10; ma->M11 = m11; ma->M12 = m12; ma->M13 = m13;
	ma->M20 = m20; ma->M21 = m21; ma->M22 = m22; ma->M23 = m23;
	ma->M30 = m30; ma->M31 = m31; ma->M32 = m32; ma->M33 = m33;
} 

void multiply_matrice(MATRICE_PTR ma, MATRICE_PTR mb, MATRICE_PTR mprod) {
	int row,col,index;
	for (row=0; row<4; row++) {
		for (col=0; col<4; col++) {
			float sum = 0; 
			for (index = 0; index < 4; index++) {
				sum += (ma->M[row][index] * mb->M[index][col]);
			} 
			mprod->M[row][col] = sum;
        } 
    } 
} 

void build_rotation_matrice(float theta_x, float theta_y, float theta_z, MATRICE_PTR mrot)  {
	MATRICE mx, my, mz, mtmp;       							
	float sin_theta = 0, cos_theta = 0;						   	  							
	MAT_IDENTITY(mrot);										
	cos_theta = cos(theta_x);
	sin_theta = sin(theta_x);
	init_matrice(&mx, 	1,    0,         0,         0,
						0,    cos_theta, sin_theta, 0,
						0,   -sin_theta, cos_theta, 0,
						0,    0,         0,         1);
	cos_theta = cos(theta_y);
	sin_theta = sin(theta_y);
	init_matrice(&my,	cos_theta, 0, -sin_theta, 0,  
						0,         1,  0,         0,
						sin_theta, 0,  cos_theta,  0,
						0,         0,  0,          1);
	cos_theta = cos(theta_z);
	sin_theta = sin(theta_z);
	init_matrice(&mz, 	cos_theta, 	sin_theta, 0, 0,  
						-sin_theta, cos_theta, 0, 0,
						0,         	0,         1, 0,
						0,         	0,         0, 1);
	multiply_matrice(&mx, &my, &mtmp);
	multiply_matrice(&mtmp, &mz, mrot);
}

void Init_CAM4DV1(CAMERA_PTR cam, POINT4D_PTR cam_pos, VECTOR4D_PTR cam_dir, float near_z, float far_z, float fov, float viewport_width, float viewport_height) {
		cam->pos.x = cam_pos->x;cam->pos.y = cam_pos->y;cam->pos.z = cam_pos->z;cam->pos.w = cam_pos->w;
		cam->dir.x = cam_dir->x;cam->dir.y = cam_dir->y;cam->dir.z = cam_dir->z;cam->dir.w = cam_dir->w;
		cam->near_z = near_z; cam->far_z  = far_z;     	
		cam->viewport_width  = viewport_width; cam->viewport_height = viewport_height;
		cam->viewport_center_x = (viewport_width-1)/2; cam->viewport_center_y = (viewport_height-1)/2;
		cam->aspect_ratio = (float) viewport_width / (float) viewport_height;
		MAT_IDENTITY(&cam->mcam); MAT_IDENTITY(&cam->mper); MAT_IDENTITY(&cam->mscr);
		cam->fov = fov; cam->viewplane_width  = 2.0; cam->viewplane_height = 2.0/cam->aspect_ratio;
		float tan_fov_div2 = tan(DEG_TO_RAD(fov / 2));
		cam->view_dist = (0.5) * (cam->viewplane_width) * tan_fov_div2;
		POINT3D pt_origin; pt_origin.x = 0.0; pt_origin.y = 0.0; pt_origin.z = 0.0;
		VECTOR3D vn; 
		vn.x =  1.0;vn.y =  0.0;vn.z = -1.0; init_plane(&cam->rt_plane, &pt_origin, &vn);
		vn.x = -1.0;vn.y =  0.0;vn.z = -1.0; init_plane(&cam->lt_plane, &pt_origin, &vn);
		vn.x =  0.0;vn.y =  1.0;vn.z = -1.0; init_plane(&cam->tp_plane, &pt_origin, &vn);
		vn.x =  0.0;vn.y = -1.0;vn.z = -1.0; init_plane(&cam->bt_plane, &pt_origin, &vn); 		
}

void build_camera(CAMERA_PTR cam) {
	MATRICE mt_inv, mx_inv, my_inv, mz_inv, mrot, mtmp; 
	init_matrice(&mt_inv, 	1,    0,     0,     0,
							0,    1,     0,     0,
							0,    0,     1,     0,
							-cam->pos.x, -cam->pos.y, -cam->pos.z, 1);
	float theta_x = cam->dir.x; float theta_y = cam->dir.y; float theta_z = cam->dir.z;
	float cos_theta = cos(theta_x); float sin_theta = -sin(theta_x);	
	init_matrice(&mx_inv, 	1,    0,         0,         0,
							0,    cos_theta, sin_theta, 0,
							0,   -sin_theta, cos_theta, 0,
							0,    0,         0,         1);
	cos_theta = cos(theta_y); sin_theta = -sin(theta_y); 
	init_matrice(&my_inv,	cos_theta, 0, -sin_theta, 0,  
							0,         1,  0,         0,
							sin_theta, 0,  cos_theta,  0,
							0,         0,  0,          1);
	cos_theta = cos(theta_z); sin_theta = -sin(theta_z);
	init_matrice(&mz_inv, 	cos_theta, sin_theta, 0, 0,  
							-sin_theta, cos_theta, 0, 0,
							0,         0,         1, 0,
							0,         0,         0, 1);
	multiply_matrice(&mz_inv, &my_inv, &mtmp);
	multiply_matrice(&mtmp, &mx_inv, &mrot);	
	multiply_matrice(&mt_inv, &mrot, &cam->mcam);
}
